
--- vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
-- vvv test template -- avoid on_init/on_config headache
if (true) then
	log("TestTemplates - begin")

	script.on_nth_tick(68, DoRunOnce)

	function SetArmour(player)
		log("SetArmour(): " .. player.name)
		local equipment = {}
		equipment["fusion-reactor-equipment"] = 4
		equipment["personal-roboport-equipment"] = 5
		equipment["battery-mk2-equipment"] = 8
		
		player.insert{ name = "construction-robot", count = 50 }
			
		player.get_inventory(defines.inventory.character_armor).clear()
		player.insert{name="power-armor-mk2", count = 1}
		local grid = player.get_inventory(defines.inventory.character_armor)[1].grid
		for k, v in pairs(equipment) do
			for c = 1, v do
				grid.put({ name = k })
			end
		end	
		
	end

	function DoRunOnce(event)
		log("DoRunOnce()")
		
		global.TestTemplate = global.TestTemplate or {}
		
		-- New game
		if not global.TestTemplate.GameInited then
			for i, player in pairs(game.players) do
				if player.valid then
					if player.character then	
						SetArmour(player)
						player.cheat_mode = true
					end
				end
			end
			for index, force in pairs(game.forces) do
				force.research_all_technologies()
			end
			
			global.TestTemplate.GameInited = true
		end

		-- Every load
		for i, player in pairs(game.players) do
			if player.valid then
				if player.cheat_mode == true then
					player.print("Cheat!!!")				
				end
			end
		end
		script.on_nth_tick(68, nil)	
	end

	script.on_nth_tick(68, DoRunOnce)
end
-- ^^^ test template
--- ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

script.on_event(defines.events.on_built_entity,
	function (event)
		local player = game.players[event.player_index]
		
		-- This spills mags and fills 'spilled' with the array of 50 entities as expected..
		local spilled = player.surface.spill_item_stack(
			player.position,
			{ name = "firearm-magazine", count = 50 }
		)
		
		-- This spills mags as expected (but no return obviously)
		player.surface.spill_item_stack(
			player.position,
			{ name = "firearm-magazine", count = 50 },
			true	
		)		
	end
)

script.on_event(defines.events.on_player_mined_item,
	function (event)	
		local player = game.players[event.player_index]
		
		-- This gives "attempt to index boolean" error ???
		local badspill = player.surface.spill_item_stack(
			player.position,
			{ name = "firearm-magazine", count = 50 },
			true	
		)
	end
)
		


